/* avatar.c generated by valac 0.9.7, the Vala compiler
 * generated from avatar.vala, do not modify */

/*
 * Copyright (C) 2010 Collabora Ltd.
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Travis Reitter <travis.reitter@collabora.co.uk>
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>


#define FOLKS_TYPE_AVATAR (folks_avatar_get_type ())
#define FOLKS_AVATAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FOLKS_TYPE_AVATAR, FolksAvatar))
#define FOLKS_IS_AVATAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FOLKS_TYPE_AVATAR))
#define FOLKS_AVATAR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FOLKS_TYPE_AVATAR, FolksAvatarIface))

typedef struct _FolksAvatar FolksAvatar;
typedef struct _FolksAvatarIface FolksAvatarIface;

struct _FolksAvatarIface {
	GTypeInterface parent_iface;
	GFile* (*get_avatar) (FolksAvatar* self);
	void (*set_avatar) (FolksAvatar* self, GFile* value);
};



GType folks_avatar_get_type (void) G_GNUC_CONST;
GFile* folks_avatar_get_avatar (FolksAvatar* self);
void folks_avatar_set_avatar (FolksAvatar* self, GFile* value);



GFile* folks_avatar_get_avatar (FolksAvatar* self) {
	return FOLKS_AVATAR_GET_INTERFACE (self)->get_avatar (self);
}


void folks_avatar_set_avatar (FolksAvatar* self, GFile* value) {
	FOLKS_AVATAR_GET_INTERFACE (self)->set_avatar (self, value);
}


static void folks_avatar_base_init (FolksAvatarIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		/**
		   * An avatar for the contact.
		   *
		   * An avatar is a small image file which represents the contact. It may be
		   * `null` if unset.
		   */
		g_object_interface_install_property (iface, g_param_spec_object ("avatar", "avatar", "avatar", G_TYPE_FILE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	}
}


/**
 * Interface for classes which represent contacts which have an avatar
 * (pictorial representation), such as {@link Persona} and {@link Individual}.
 */
GType folks_avatar_get_type (void) {
	static volatile gsize folks_avatar_type_id__volatile = 0;
	if (g_once_init_enter (&folks_avatar_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FolksAvatarIface), (GBaseInitFunc) folks_avatar_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType folks_avatar_type_id;
		folks_avatar_type_id = g_type_register_static (G_TYPE_INTERFACE, "FolksAvatar", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (folks_avatar_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&folks_avatar_type_id__volatile, folks_avatar_type_id);
	}
	return folks_avatar_type_id__volatile;
}




